
; Lusta lista minden elemre kirtkeli proc eljrst
(define (stream-for-each proc s) 
	(if (stream-null? s) 
		'done 
		(begin (proc (stream-car s)) 
			(stream-for-each proc (stream-cdr s)))))
	
; Lusta lista kiirato eljaras
(define (display-stream s) 
	(stream-for-each display-line s)) 
(define (display-line x) 
	(newline) 
	(display x))
	

(define (stream-enumerate-interval low high) 
	(if (> low high) 
		the-empty-stream 
		(cons-stream 
			low 
			(stream-enumerate-interval (+ low 1) high))))
			
#|
(stream-enumerate-interval 10000 1000000) ; hivas eseten kaphatjuk: 
(cons 10000 (delay (stream-enumerate-interval 10001 1000000))) ; eredmenyt
|#

(define (stream-filter pred stream) 
	(cond 
		((stream-null? stream) the-empty-stream)	; ures lista
		((pred (stream-car stream)) 				; ha igaz a lista elso elemere a szures
			(cons-stream (stream-car stream) 		; keszit egy lusta listat a jelenlegi lista fejevel
				(stream-filter pred (stream-cdr stream)))) ; illetve a maradek lusta lista szurtjenek a igeretevel
		(else (stream-filter pred (stream-cdr stream))))) ; egyebkent kihagyja a lista fejet es tovabbhalad


#|
(stream-car 
	(stream-cdr 
		(stream-filter (lambda (x) (> x 10007)) 
		(stream-enumerate-interval 10000 1000000))))
|#		

#|
A lista alakulasa:
(cons 10000 (delay (stream-enumerate-interval 10001 1000000)))
(cons 10001 (delay (stream-enumerate-interval 10002 1000000)))
(cons 10002 (delay (stream-enumerate-interval 10003 1000000)))
(cons 10003 (delay (stream-enumerate-interval 10004 1000000)))
(cons 10004 (delay (stream-enumerate-interval 10005 1000000)))
(cons 10005 (delay (stream-enumerate-interval 10006 1000000)))
(cons 10006 (delay (stream-enumerate-interval 10007 1000000)))
(cons 10007 (delay (stream-enumerate-interval 10008 1000000)))
(cons 10008 (delay (stream-enumerate-interval 10009 1000000)))

Ekkor stream-filter az alabbit adja vissza:
(cons 10008 (delay (stream-filter <lambda fv> (cons 10009 (delay (stream-enumerate-interval 10010 1000000))))))
(stream-car
    (stream-cdr
	(cons 10008 (delay (stream-filter <lambda fv> (cons 10009 (delay (stream-enumerate-interval 10010 1000000))))))))
	
pedig meg egy kiertekeltetest vegez (delay (stream-filter <lambda fv> (cons 10009 (delay (stream-enumerate-interval 10010 1000000))))))-en
igy a vegeredmeny 10009-lesz
|#