

(define (square x) (* x x))
(define (average x y) (/ (+ x y) 2))

;;; A program elkulonulo eljarasokbol all.
#|
(define (good-enough? guess x) 
	(< (abs (- (square guess) x)) 0.01))
(define (improve guess x) 
	(average guess (/ x guess)))
(define (sqrt-iter guess x) 
	(if (good-enough? guess x) 
		guess
		(sqrt-iter (improve guess x) x)))

(define (squareroot x) 
	(sqrt-iter 1.0 x)) 
|#
	
;;; A felhasznalo csak a sqrt eljarast kivanja hivni, 
;;; igy a segedeljarasokat elrejtjuk belso definiciokent.
#|
(define (squareroot x)
	(define (good-enough? guess x)
		(< (abs (- (square guess) x)) 0.001))
	(define (improve guess x) 
		(average guess (/ x guess)))
	(define (sqrt-iter guess x)
		(if (good-enough? guess x)
			guess
			(sqrt-iter (improve guess x) x)))
	(sqrt-iter 1.0 x))
|#

	
;;; x - et megkotjuk sqrt hivasakor, igy a segedfuggvenyek
;;; amelyek mar sqrt belso definicioi x-nek "scope"-jaban 
;;; vannak, ezert nem szukseges parameterkent atadni oket.
;;; Ezt hivjuk lexical-scope -nak.
(define (squareroot x) 
	(define (good-enough? guess)
		(< (abs (- (square guess) x)) 0.001))
	(define (improve guess) 
		(average guess (/ x guess)))
	(define (sqrt-iter guess)
		(if (good-enough? guess)
			guess
			(sqrt-iter (improve guess))))
	(sqrt-iter 1.0))
