;;; Adatreprezentacio fuggo resz

; Valtozo-e x
(define (variable? x) (symbol? x)) 

; v1 es v2 ugyanaz a valtozo-e
(define (same-variable? v1 v2) 
	(and (variable? v1) (variable? v2) (eq? v1 v2)))
	
; a1 es a2 szimbolumok osszege, lista reprezentacioban
(define (make-sum a1 a2) (list '+ a1 a2))

; m1 es m2 szimbolumok szorzata lista reprezentacioban
(define (make-product m1 m2) (list '* m1 m2))

; osszeg-e x
(define (sum? x) 
	(and (pair? x) (eq? (car x) '+)))
	
; Az s osszeg elso operandusa
(define (addend s) (cadr s))

; Az s osszeg masodik operandusa
(define (augend s) (caddr s))

; Szorzat-e a szimbolum
(define (product? x) 
	(and (pair? x) (eq? (car x) '*)))
	
; Szorzo
(define (multiplier p) (cadr p))

; Szorzando
(define (multiplicand p) (caddr p))

;;; Szimbolikus, absztrakt adattipusra mukodo resz

; A derivalas szabalyait megvalosito kodreszlet
(define (deriv exp var) 
	(cond 
		((number? exp) 
			0) 
		((variable? exp) 
			(if (same-variable? exp var) 1 0)) 
		((sum? exp) 
			(make-sum 
				(deriv (addend exp) var) 
				(deriv (augend exp) var))) 
		((product? exp) 
			(make-sum 
				(make-product (multiplier exp) (deriv (multiplicand exp) var)) 
				(make-product (deriv (multiplier exp) var) (multiplicand exp)))) 
		(else (error "unknown expression type -- DERIV" exp))))
		

; Peldak
; (deriv '(* (* x y) (+ x 3)) 'x)
; (deriv '(+ (+ x y) (* y y)) 'y)		

		
		
		
		